<template>
  <main class="main cart min-vh-2">
    <div class="cart__left py-3 py-lg-4 py-xl-5">
      <client-only>
        <b-container>
          <b-row>
            <b-col class="cart__right py-3 py-lg-4 py-xl-5 px-3 px-lg-4" md="4" lg="4">
              <div class="pb-4 mb-4 border-bottom">
                <h3 class="cart--title h4">
                  <template v-if="step === 1">
                    {{ $t('cart.order_summary') }}
                  </template>
                  <template v-else-if="step === 2">
                    {{ $t('cart.personal_data') }}
                  </template>
                </h3>
              </div>
              <client-only>
                <div class="d-flex flex-row justify-content-between align-items-end py-2 text-uppercase font-weight-bold">
                  <span class="pr-1">{{ $t('cart.products_cost') }}</span>
                  <span v-html="getPrice(totalPrice)" />
                </div>
                <div class="py-2 cart__right__body">
                  <template v-if="step === 1">
                    <b-form-group
                      id="groupCurrency"
                      :label="$t('cart.currency')"
                      label-for="inputCurrency"
                      class="py-2 mb-1"
                    >
                      <b-form-select
                        id="inputCurrency"
                        :value="currencyValue"
                        :state="true"
                        :disabled="!cartItemQuantity"
                        @input="setCurrency($event)"
                      >
                        <b-form-select-option
                          v-for="item in currencies"
                          :key="item.kod"
                          :value="item.kod"
                        >
                          {{ item.kod }}
                        </b-form-select-option>
                      </b-form-select>
                    </b-form-group>
                    <b-form-group
                      id="groupShipping"
                      :label="$t('cart.shipping')"
                      class="pb-2 mb-1"
                    >
                      <b-form-radio v-model="form.shipping" value="">
                        {{ $t('cart.pickup') }}
                      </b-form-radio>
                      <b-form-radio
                        v-for="item in deliveries"
                        :key="'delivery-' + item.id"
                        v-model="form.shipping"
                        :value="item"
                      >
                        <div class="d-flex justify-content-between">
                          {{ item.name }} <span class="font-weight-bold" v-html="getPrice(item.price)" />
                        </div>
                        <div class="small text-secondary">
                          {{ $t('delivery_date') }}
                          <br>
                          {{ getDeliveryDate(item.days) }}
                        </div>
                      </b-form-radio>
                    </b-form-group>
                    <template v-if="form.shipping">
                      <div class="pb-4 mt-4 mb-3 border-bottom">
                        <h3 class="cart--title h4">
                          {{ $t('cart.address') }}
                        </h3>
                      </div>
                      <div>
                        <b-form-group
                          id="groupStreet"
                          :label="$t('form.street')"
                          label-for="inputStreet"
                          class="py-2 mb-1"
                        >
                          <b-form-input id="inputStreet" v-model="form.address.street" :state="isValidStreet" />
                        </b-form-group>
                        <b-form-group
                          id="groupCity"
                          :label="$t('form.city')"
                          label-for="inputCity"
                          class="py-2 mb-1"
                        >
                          <b-form-input
                            id="inputCity"
                            v-model="form.address.city"
                            :disabled="!isValidStreet"
                            :state="isValidCity"
                          />
                        </b-form-group>
                        <b-form-group
                          id="groupCountry"
                          :label="$t('form.country')"
                          label-for="inputCountry"
                          class="py-2 mb-1"
                        >
                          <b-form-select
                            id="inputCountry"
                            v-model="form.address.country"
                            :disabled="!(isValidStreet && isValidCity)"
                            :state="isValidCountry"
                          >
                            <b-form-select-option value="" disabled>
                              {{ $t('form.select_country') }}
                            </b-form-select-option>
                            <b-form-select-option
                              v-for="(countryName, countryCode) in countries"
                              :key="countryCode"
                              :value="countryCode"
                            >
                              {{ countryName }}
                            </b-form-select-option>
                          </b-form-select>
                        </b-form-group>
                        <b-form-group
                          id="groupZipCode"
                          :label="$t('form.zip_code')"
                          label-for="inputZipCode"
                          class="py-2 mb-1"
                        >
                          <b-form-input
                            id="inputZipCode"
                            v-model="form.address.zipCode"
                            :disabled="!(isValidStreet && isValidCity && isValidCountry)"
                            :state="isValidZipCode"
                          />
                        </b-form-group>
                      </div>
                    </template>
                    <div v-else v-html="addressInfo" />
                  </template>
                  <template v-else-if="step === 2">
                    <!--            <b-form-group-->
                    <!--              id="groupName"-->
                    <!--              :label="$t('form.name')"-->
                    <!--              label-for="inputName"-->
                    <!--              class="py-2 mb-1"-->
                    <!--            >-->
                    <!--              <b-form-input id="inputName" v-model="form.name" :state="isValidName" />-->
                    <!--            </b-form-group>-->
                    <!--            <b-form-group-->
                    <!--              id="groupSurname"-->
                    <!--              :label="$t('form.surname')"-->
                    <!--              label-for="inputSurname"-->
                    <!--              class="py-2 mb-1"-->
                    <!--            >-->
                    <!--              <b-form-input id="inputSurname" v-model="form.surname" :state="isValidSurname" />-->
                    <!--            </b-form-group>-->
                    <b-form-group
                      id="groupEmail"
                      :label="$t('form.email')"
                      label-for="inputEmail"
                      class="py-2 mb-1"
                    >
                      <b-form-input id="inputEmail" v-model="form.email" :state="isValidEmail" />
                    </b-form-group>
                    <b-form-group
                      id="groupPhone"
                      :label="$t('form.phone')"
                      label-for="inputPhone"
                      class="py-2 mb-1"
                    >
                      <b-form-input
                        id="inputPhone"
                        v-model="form.phone"
                        v-mask="phoneMask"
                        :state="isValidPhone"
                      />
                    </b-form-group>
                  </template>
                </div>
                <div class="d-flex flex-row justify-content-between align-items-end py-3 text-uppercase font-weight-bold">
                  <span class="pr-1">{{ $t('cart.total_cost') }}</span>
                  <div class="d-flex flex-row justify-content-between align-items-center">
                    <template v-if="form.shipping">
                      <template v-if="form.discount">
                        <span
                          class="text-danger text-decor-underline mr-2 small"
                          v-html="getPrice(totalPrice, true, form.shipping.price)"
                        />
                        <span v-html="getPrice(totalPrice, true, form.shipping.price, form.discount)" />
                      </template>
                      <span v-else v-html="getPrice(totalPrice, true, form.shipping.price, form.discount)" />
                    </template>
                    <template v-else>
                      <span
                        v-if="form.discount"
                        class="text-danger text-decor-underline mr-2 small"
                        v-html="getPrice(totalPrice)"
                      />
                      <span v-html="getPrice(totalPrice, true, 0, form.discount)" />
                    </template>
                  </div>
                </div>

                <template v-if="step === 2">
                  <!--                  <div class="mb-3">-->
                  <!--                    <div class="form-check">-->
                  <!--                      <input id="oncePay" v-model="form.payType" class="form-check-input" type="radio" value="once">-->
                  <!--                      <label class="form-check-label small" for="oncePay" v-html="$t('payType.once', {sum: getPrice(totalPrice + (form.shipping ? form.shipping.price : 0))})" />-->
                  <!--                    </div>-->
                  <!--                    <div class="form-check">-->
                  <!--                      <input id="creditPay" v-model="form.payType" class="form-check-input" type="radio" value="credit">-->
                  <!--                      <label class="form-check-label small" for="creditPay" v-html="$t('payType.credit', {sum: getPrice(firstPayment), months})" />-->
                  <!--                    </div>-->
                  <!--                  </div>-->
                  <div class="mb-3">
                    <span class="form-check-label small pl-0 text-secondary" v-html="$t('agree_oferta')" />
                  </div>
                </template>
                <b-button
                  v-if="step === 1"
                  variant="primary"
                  class="btn--bottomed w-100 mb-2"
                  :disabled="!(cartItemQuantity && (!form.shipping || (form.shipping && isValidStreet && isValidCity && isValidCountry && isValidZipCode)))"
                  @click="onContinue"
                >
                  {{ $t('continue') }}
                </b-button>
                <div v-else-if="step === 2" class="d-flex flex-column">
                  <b-form-input
                    id="inputPromocode"
                    v-model="form.promocode"
                    size="sm"
                    class="mb-2"
                    autocomplete="off"
                    :class="{'border-warning': !promoStatus, 'border-danger': promoStatus === 'error', 'border-success': promoStatus === 'success'}"
                    :placeholder="$t('form.promocode')"
                    @blur="checkPromo()"
                  />
                  <small v-if="promoStatus" class="promocode mb-2" :class="'promocode-' + promoStatus">
                    {{ $t('promocode_status.' + promoStatus) }}
                  </small>
                  <b-button
                    variant="primary"
                    class="btn--bottomed w-100 mb-2"
                    :disabled="!(isValidEmail && isValidPhone && isAgree)"
                    @click="onSubmit('once')"
                  >
                    {{ $t('cart.checkout') }}
                  </b-button>
                  <template v-if="promoStatus !== 'success'">
                    <b-button
                      variant="warning"
                      class="btn--bottomed w-100 mb-2 text-white"
                      :disabled="!(isValidEmail && isValidPhone && isAgree)"
                      @click="onSubmit('credit')"
                    >
                      {{ $t('cart.checkout_credit') }}
                    </b-button>
                    <small class="text-secondary" v-html="'*' + $t('payType.credit', {sum: getPrice(firstPayment), months})" />
                  </template>
                </div>
                <b-button
                  v-if="step > 1"
                  variant="link"
                  class="d-flex align-items-center px-0"
                  @click="step--"
                >
                  <b-img src="@/static/icons/left-arrow.svg" alt="Left" width="32" class="mr-2" />
                  {{ $t('cart.back') }}
                </b-button>
              </client-only>
            </b-col>
            <b-col ref="cartLeft" class="py-3 py-lg-4 py-xl-5 px-3 px-lg-4" md="8" lg="8">
              <div class="d-flex flex-row justify-content-between align-items-start border-bottom pb-2 pb-3 mb-3 mb-md-4">
                <h1 class="cart--title h3">
                  {{ $t('cart.name') }}
                </h1>
                <span v-if="cartItemQuantity" class="text-secondary h4">{{ itemsText }}</span>
              </div>
              <template
                v-if="cartItemQuantity"
              >
                <b-table
                  responsive
                  borderless
                  :items="rows"
                  :fields="fields"
                  :busy="!rows"
                >
                  <template v-slot:table-busy>
                    <div class="text-center text-danger my-2">
                      <b-spinner class="align-middle" variant="secondary" />
                    </div>
                  </template>
                  <template v-slot:cell(product_detail)="data">
                    <b-media class="product-detail">
                      <template v-slot:aside>
                        <v-lazy-image
                          :src-placeholder="data.item.product.cover | image | imageSize('small')"
                          :src="data.item.product.cover | image"
                          :alt="data.item.product.title"
                        />
                      </template>
                      <div class="d-flex flex-column justify-content-between">
                        <h6
                          class="mt-0 mb-2 small"
                          v-html="$t('namebook.book_for', {book: data.item.product.title, name: genitiveName(data.item.name, data.item.gender) })"
                        />
                        <small class="d-block d-md-none text-primary" v-html="getPrice(data.item.product.price)" />
                        <span class="edit d-none d-md-block" @click="edit(data.item)"> <b-img src="@/static/icons/edit.svg" alt="Edit" class="edit__icon" /><span>{{ $t('cart.edit') }}</span></span>
                        <span class="remove d-none d-md-block" @click="removeCartItem({id: data.item.id})"> <b-img src="@/static/icons/remove.svg" alt="Remove" class="remove__icon" /><span>{{ $t('cart.remove') }}</span></span>
                      </div>
                    </b-media>
                  </template>
                  <template v-slot:cell(price)="data">
                    <span class="d-none d-md-block" v-html="getPrice(data.item.product.price)" />
                    <span class="edit d-inline d-md-none" @click="edit(data.item)"> <b-img src="@/static/icons/edit.svg" alt="Edit" class="edit__icon" /></span>
                    <span class="remove d-inline d-md-none" @click="removeCartItem({id: data.item.id})"> <b-img src="@/static/icons/remove.svg" alt="Remove" class="remove__icon" /></span>
                  </template>
                  <template v-slot:row-details="data">
                    <table class="w-100">
                      <b-tr v-for="(addon, index) in data.item.addons" :key="'addon-' + index">
                        <b-td>
                          <b-media class="product-detail">
                            <template v-slot:aside>
                              <v-lazy-image
                                :src-placeholder="addon.cover | image | imageSize('small')"
                                :src="addon.cover | image"
                                :alt="addon.title"
                              />
                            </template>
                            <div class="d-flex flex-column justify-content-between">
                              <h6
                                class="mt-0 mb-2 small"
                              >
                                {{ addon.title }}
                                <strong>({{ data.item.product.title }})</strong>
                              </h6>
                              <small class="d-block d-md-none text-primary" v-html="getPrice(addon.price)" />
                              <span
                                class="remove d-none d-md-block"
                                @click="removeCartItemAddon({id: data.item.id, addonId: addon.id})"
                              >
                                <b-img src="@/static/icons/remove.svg" alt="Remove" class="remove__icon" />
                                <span>{{ $t('cart.remove') }}</span></span>
                            </div>
                          </b-media>
                        </b-td>
                        <b-td>
                          <span class="d-none d-md-block" v-html="getPrice(addon.price)" />
                          <span
                            class="remove d-inline d-md-none"
                            @click="removeCartItemAddon({id: data.item.id, addonId: addon.id})"
                          >
                            <b-img src="@/static/icons/remove.svg" alt="Remove" class="remove__icon" /></span>
                        </b-td>
                      </b-tr>
                    </table>
                  </template>
                </b-table>
                <b-button
                  variant="link"
                  class="px-0 d-flex align-items-center"
                  :to="localePath({ name: 'namebooks-id', params: {id: 1} })"
                >
                  <b-img src="@/static/icons/left-arrow.svg" alt="Left" width="32" class="mr-2" />
                  {{ $t('cart.continue_shopping') }}
                </b-button>
              </template>
              <b-card v-else no-body>
                <b-card-body class="text-center py-5">
                  <b-card-title class="mb-3">
                    {{ $t('cart.empty_cart') }}
                  </b-card-title>
                  <b-button
                    variant="primary"
                    class="btn--bottomed"
                    :to="localePath({ name: 'namebooks-id', params: {id: 1} })"
                  >
                    {{ $t('cart.continue_shopping') }}
                  </b-button>
                </b-card-body>
              </b-card>
            </b-col>
          </b-row>
        </b-container>
      </client-only>
    </div>
    <b-modal id="successModal" centered hide-header footer-class="justify-content-center">
      <p class="m-4 text-center d-flex align-items-center justify-content-center flex-column text-dark h5">
        <img src="~/static/icons/confetti.svg" alt="Success" width="64" class="mb-4">
        <span>{{ $t('cart.success_pay', { 'name': order ? order.email : $t('cart.guest') }) }}</span>
      </p>
      <template v-slot:modal-footer class="justify-content-center">
        <ul v-if="socials" class="socials list-unstyled list-inline text-center">
          <li class="list-inline-item mx-1">
            <a :href="socials.instagram" target="_blank">
              <b-img src="~/static/icons/instagram.svg" alt="Instagram" />
            </a>
          </li>
          <li class="list-inline-item mx-1">
            <a :href="socials.facebook" target="_blank">
              <b-img src="~/static/icons/facebook.svg" alt="Facebook" />
            </a>
          </li>
        </ul>
      </template>
    </b-modal>
    <b-modal id="errorModal" centered hide-header footer-class="justify-content-center">
      <p class="m-4 text-center d-flex align-items-center justify-content-center flex-column text-danger">
        <img src="~/static/icons/sad.svg" alt="Error" width="64" class="mb-4">
        <span v-html="$t('cart.error_pay', { phone })" />
      </p>
      <template v-slot:modal-footer class="justify-content-center">
        <ul v-if="socials" class="socials list-unstyled list-inline text-center">
          <li class="list-inline-item mx-1">
            <a :href="socials.instagram" target="_blank">
              <b-img src="~/static/icons/instagram.svg" alt="Instagram" />
            </a>
          </li>
          <li class="list-inline-item mx-1">
            <a :href="socials.facebook" target="_blank">
              <b-img src="~/static/icons/facebook.svg" alt="Facebook" />
            </a>
          </li>
        </ul>
      </template>
    </b-modal>
  </main>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'
import postalCodes from 'postal-codes-js'

export default {
  name: 'AppCart',
  data () {
    return {
      // left: 'inherit',
      deliveries: [],
      countries: require('~/static/json/countries/' + this.$i18n.locale + '.json'),
      fields: [
        {
          key: 'product_detail',
          label: this.$t('cart.product_detail')
        },
        {
          key: 'price',
          label: this.$t('cart.price')
        }
      ],
      form: {
        shipping: '',
        name: '',
        surname: '',
        email: '',
        phone: '',
        address: {
          street: '',
          city: '',
          country: '',
          zipCode: ''
        },
        payType: 'once',
        promocode: '',
        discount: 0
      },
      step: 1,
      phoneMask: '+7 (7##)-###-##-##',
      phoneFocused: false,
      order: null,
      months: 2,
      isAgree: true,
      promoStatus: null
    }
  },
  computed: {
    ...mapGetters({
      items: 'cart/getItems',
      cartItemQuantity: 'cart/getTotalItemQuantity',
      totalPrice: 'cart/getTotalPrice',
      currency: 'currency/getCurrency',
      currencies: 'currency/getCurrencies',
      phone: 'settings/getPhone',
      socials: 'settings/getSocials'
    }),
    addressInfo () {
      return this.$store.state.settings['address_' + this.$i18n.locale]
    },
    currencyValue () {
      return this.currency || 'KZT'
    },
    itemsText () {
      return this.$t('cart.items.' + this.$options.filters.declareNum([0, 1, 2], this.cartItemQuantity),
        { count: this.cartItemQuantity })
    },
    rows () {
      return this.items.map((item) => {
        const newItem = Object.assign({}, item)
        newItem._showDetails = !!item.addons.length
        return newItem
      })
    },
    // isValidName () {
    //   return this.form.name.length ? true : null
    // },
    // isValidSurname () {
    //   return this.form.surname.length ? true : null
    // },
    isValidEmail () {
      if (this.form.email) {
        // eslint-disable-next-line no-useless-escape
        const re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
        return re.test(String(this.form.email).toLowerCase())
      }
      return null
    },
    isValidPhone () {
      if (this.phoneFocused) {
        if (this.$device.isMobileOrTablet && !this.$device.isIos) {
          if (this.form.phone) {
            return (
              (this.form.phone.startsWith('8') ||
                            this.form.phone.startsWith('7') ||
                            this.form.phone.startsWith('+7')) &&
                    this.form.phone.length >= 11
            )
          }
          return null
        }

        return this.form.phone.length === 18
      }
      return null
    },
    isValidStreet () {
      return this.form.address.street.length ? true : null
    },
    isValidCity () {
      return this.form.address.city.length ? true : null
    },
    isValidCountry () {
      return this.form.address.country.length ? true : null
    },
    isValidZipCode () {
      if (this.form.address.country && this.form.address.zipCode.length) {
        return postalCodes.validate(this.form.address.country, this.form.address.zipCode) === true
      }
      return null
    },
    // fullname () {
    //   return this.form.name + ' ' + this.form.surname
    // },
    address () {
      if (this.isValidStreet && this.isValidCity && this.isValidCountry && this.isValidZipCode) {
        return this.form.address.street + ', ' +
            this.form.address.city + ', ' +
            this.form.address.country + ' (' +
            this.form.address.zipCode + ')'
      }
      return null
    },
    firstPayment () {
      let payment = this.totalPrice / 2
      if (this.form.shipping) {
        payment = payment + this.form.shipping.price
      }
      return payment
    },
    monthPayment () {
      let totalPayment = this.totalPrice
      if (this.form.shipping) {
        totalPayment = totalPayment + this.form.shipping.price
      }
      return this.getPrice((totalPayment - this.firstPayment) / 2, false)
    }
  },
  watch: {
    'form.phone' () {
      this.phoneFocused = true
    },
    currencyValue () {
      this.defineCountry()
    },
    cartItemQuantity () {
      if (this.cartItemQuantity === 0) {
        this.step = 1
      }
    }
  },
  mounted () {
    this.getDeliveries()
    this.defineCountry()
  },
  methods: {
    async getDeliveries () {
      const { data } = await this.$axios.$get('deliveries')
      this.deliveries = data
    },
    getPrice (price, filter = true, add = 0, discount = null) {
      if (this.currency && this.currencies.length) {
        const currency = this.currencies.find(item => item.kod === this.currency)

        if (discount) {
          price -= price * parseInt(discount) / 100
        }

        price = price + add

        if (currency.kod !== 'KZT') {
          price = (price / parseFloat(currency.kurs)).toFixed(2)
        }
      } else {
        if (discount) {
          price -= price * parseInt(discount) / 100
        }

        price = price + add
      }

      if (filter) {
        return this.$options.filters.price(price, this.currency || 'KZT')
      }
      return this.$options.filters.price(price, this.currency || 'KZT', false)
    },
    defineCountry () {
      this.form.address.country = this.currencyValue.substring(0, 2)
    },
    genitiveName (name, gender) {
      return this.$options.filters.genitive(name, this.$i18n.locale, gender)
    },
    edit (item) {
      const path = this.localePath({
        name: 'namebooks-id-edit',
        params: { id: item.product.id },
        query: {
          item: item.id
        }
      })
      this.$router.push({ path })
    },
    onContinue () {
      if (this.step === 1 && this.cartItemQuantity && (!this.form.shipping || (this.form.shipping && this.isValidStreet && this.isValidCity && this.isValidCountry && this.isValidZipCode))) {
        this.step++
      }
    },
    onSubmit (payType = 'once') {
      this.form.payType = payType
      let totalPrice = this.totalPrice

      if (this.form.discount) {
        totalPrice = totalPrice * ((100 - this.form.discount) / 100)
      }

      if (this.form.shipping) {
        totalPrice += this.form.shipping.price
      }

      const amount = payType === 'credit' ? this.getPrice(this.firstPayment, false) : parseFloat(this.getPrice(this.totalPrice, false, this.form.shipping.price || 0, this.form.discount || 0))
      const data = {
        // fullname: this.fullname,
        email: this.form.email,
        phone: this.form.phone,
        address: this.address,
        original_price: totalPrice,
        price: amount,
        currency: this.currencyValue,
        delivery: this.form.shipping.id || null,
        products: this.items,
        promocode: this.form.discount ? this.form.promocode : null,
        payType
      }

      this.$axios.$post('order', data).then((response) => {
        this.order = response
        this.openWidget()
      }).catch(() => {
        self.$bvModal.show('errorModal')
      })
    },
    openWidget () {
      const self = this
      let language = 'ru-RU'
      if (this.$i18n.locale === 'kk') {
        language = 'kk-KZ'
      }
      // eslint-disable-next-line no-undef
      const widget = new cp.CloudPayments({ language })

      const data = {
        // name: this.order.fullname,
        phone: this.order.phone,
        address: this.order.address
      }

      let amount = this.order.price

      if (this.form.payType === 'credit') {
        console.log(this.monthPayment)
        data.cloudPayments = {
          recurrent: { interval: 'Month', period: 1, amount: this.monthPayment, maxPeriods: this.months }
        }

        amount = this.getPrice(this.firstPayment, false)
      }

      // console.log(data, amount)

      // const self = this
      widget.charge({ // options
        publicId: process.env.CLOUDPAYMENTS_CLIENT_ID,
        description: this.form.payType === 'credit' ? this.$t('cart.credit_description') : this.$t('cart.pay_description'),
        amount,
        currency: this.order.currency,
        invoiceId: this.order.id,
        accountId: this.order.email,
        email: this.order.email,
        requireEmail: true,
        skin: 'mini',
        data
      },
      () => self.checkOrder(),
      (reason) => {
        if (reason !== 'User has cancelled') {
          console.log('cancelled')
          self.$bvModal.show('errorModal')
        }
      })

      window.onbeforeunload = function () {
        self.checkOrder()
      }
    },
    checkOrder () {
      this.$axios.$post('orders/' + this.order.id + '/check').then(() => {
        console.log('success')
        this.$bvModal.show('successModal')
        this.clearCart()
      })
    },
    checkPromo () {
      if (this.form.promocode.length >= 4) {
        this.$axios.$post('promocodes/' + this.form.promocode).then((data) => {
          this.promoStatus = 'success'
          this.form.discount = data.promocode.discount
        }).catch(() => {
          this.promoStatus = 'error'
          this.form.discount = 0
        })
      } else {
        this.promoStatus = null
        this.form.discount = 0
      }
    },
    getDeliveryDate (days) {
      const startDate = this.$dayjs().add(days, 'day').locale(this.$i18n.locale).format('D MMMM')
      const endDate = this.$dayjs().add(days + 5, 'day').locale(this.$i18n.locale).format('D MMMM')
      return startDate + ' - ' + endDate
    },
    ...mapActions({
      setCurrency: 'currency/SET_CURRENCY',
      removeCartItem: 'cart/REMOVE_FROM_CART',
      removeCartItemAddon: 'cart/REMOVE_ADDON_FROM_CART',
      clearCart: 'cart/CLEAR_CART'
    })
  },
  head () {
    return {
      script: [
        {
          hid: 'cloudpayments',
          src: 'https://widget.cloudpayments.kz/bundles/cloudpayments',
          type: 'text/javascript',
          defer: true
        }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
    //noinspection CssUnknownTarget
    @import "@/assets/scss/_variables.scss";
    @import "~bootstrap/scss/mixins/breakpoints";

    .cart {
        position: relative;

        .cart__left {
            @include media-breakpoint-up(md) {
                min-height: 44rem;
            }
        }

        .cart__right {
            /*position: absolute;*/
            height: 100%;
            background-color: $light;
            /*overflow-y: scroll;*/
            /*right: 0;*/
            /*top: 0;*/

            &__body {
                border-bottom: 1px solid $border-color;
            }
        }

        &--title {
            color: $dark;
            font-weight: bold;
            margin: 0 !important;
        }
    }

    .product-detail {
        color: $dark;
        margin-right: 0.5rem;
        @include media-breakpoint-down(sm) {
            text-align: left;
            .mr-3 {
                margin-right: 0.5rem !important;
            }
        }

        img {
            width: 6rem;
            height: 4rem;
            object-fit: cover;
            @include media-breakpoint-only(md) {
                width: 5rem;
                height: 3rem;
            }
            @include media-breakpoint-down(sm) {
                width: 3rem;
                height: 2rem;
            }
        }
    }

    .edit, .remove {
        font-size: small;
        color: $secondary;
        cursor: pointer;
        margin-bottom: 0.25rem;
        &__icon {
            width: 1rem !important;
            height: 1rem !important;
            object-fit: contain !important;
            margin-right: 0.5rem;
            @include media-breakpoint-up(md) {
                filter: grayscale(1);
            }
        }
    }

    .edit:hover {
        color: $primary;
        .edit__icon {
            filter: none;
        }
    }

    .remove:hover {
        color: $danger;
        .remove__icon {
            filter: none;
        }
    }

    .socials {
        img {
            width: 1.5rem;
            height: 1.5rem;
            object-fit: contain;
        }
    }
</style>

<style lang="scss">
    //noinspection CssUnknownTarget
    @import "@/assets/scss/_variables.scss";
    @import "~bootstrap/scss/mixins/breakpoints";
    th {
        text-transform: uppercase;
        @include media-breakpoint-down(sm) {
            &:last-child {
              display: none;
            }
        }
    }

    td {
        &:last-child {
            width: 7rem;
        }
    }

    .table table {
        tr {
            &:first-child {
                td {
                    padding-top: 0;
                }
            }

            &:last-child {
                td {
                    padding-bottom: 0;
                }
            }
        }
    }

    .form-group {
        label, legend {
            color: black;
            text-transform: uppercase;
            font-weight: bold;
        }
    }

  .promocode {
    &-error {
      color: $danger;
    }
    &-success {
      color: $success;
    }
  }

  .text-decor-underline {
    text-decoration: line-through;
  }

  #groupShipping .custom-control-label {
    text-transform: none;
    font-weight: inherit;
    display: flex;
    flex-direction: column;
  }
</style>
